Subject: (Reply) Request for one more clarification on IP with MPLS

From: [email-masked]
Date: Mon, 13 Nov 2000 17:52:44 +0900

Dear Sandeep,

	Based on the  last Label Stack Entry (with S bit set to 1), in the label stack, you can get the L3 Address family.
At present we can come to know only whether the family is IPv4 or IPv6.
When the architecture supports other L3 Address families we may have some more reserved labels.

The following are the reserved labels, which are used at the bottom of the label stack, based on which we can guess
the L3 address family.

2.1. Encoding the Label Stack:
A value of 0 represents the "IPv4 Explicit NULL Label".
                 This label value is only legal at the bottom of the
                 label stack.  It indicates that the label stack must be
                 popped, and the forwarding of the packet must then be
                 based on the IPv4 header.
A value of 2 represents the "IPv6 Explicit NULL Label".
                 This label value is only legal at the bottom of the
                 label stack.  It indicates that the label stack must be
                 popped, and the forwarding of the packet must then be
                 based on the IPv6 header

Please also refer the section : 2.2. Determining the Network Layer Protocol (mpls-ldp-label-encaps-08.txt)
For other doubts see the inline messages.
Hope it helps u.
If I am wrong please correct me.

Regards
 Seenu
 Samsung India Software Operations
 Level 7, Prestige Meridian - II
 M.G.Road
 Bangalore

>
>
>Dear John Runham, Ramanjaneyulu and Seenu,
>
>Thank you to all of you for the prompt and detailed 
>clarifications.!!
>
> Now, I have come across another basic doubt.
> I noticed that the mpls draft :
 >  
>    draft-ietf-mpls-label-encaps-08.txt
> 
> does not  address the Ethernet - IP type field
> presence after MPLS labels :
>
 > |---------------------------------|
 > | L2  | MPLS   | IP Header	      |  	
>  |---------------------------------|
>
>  
>  In standard Ethernet-II or 802.3 LLC/SNAP (non-MPLS) 
>  switching / routing, the Type field "0x800" comes after
>  the L2 header, which indicates that it is an IP packet. 
>

---> Since L3 address family can be anything (Multi Protocol ...!!!!) no need to have 0x800 field, which identifies only
      IP packet.

>  But, in case of MPLS switched packets :
>
>  Q1.  Will the IP header after the MPLS, contain 2 bytes 
>       of Type field (0x800) in the begining of IP Header...??
>
----> No.
>                 or
>
>  Q2. For MPLS packets, Is IP the implicit protocol supported ..??
>      Thereby no type field is required after the MPLS labels and
>      the bytes after MPLS labels  "MUST" be the IP Header without
>      type field  !! 
>
>
-----> No. IP can't be the implicit L3 protocol. Please refer the above explanation.

> Thanking you all for your kind help.
>
> - Sandeep